function UpgradeWindow() {
  
  this.UPGRADE_OFFSET_Y = [ 130, 182, 234, 286, 394, 446];
  this.UPGRADE_TITLES = [ "rocket engine", "steering", "radar", "thrusters", "amplifier", "charger" ];
  this.UPGRADE_TEXTS = [ "+25% power", "+25% agility", "+10% view distance", "+ stability", "+50% damage", "+25% rate of fire" ];
  
  this.UPGRADES = [
    [
      { cost :  200, force : Math.pow(1.25, 1) },
      { cost :  500, force : Math.pow(1.25, 2) }, 
      { cost : 1200, force : Math.pow(1.25, 3) }, 
      { cost : 2500, force : Math.pow(1.25, 4) }, 
      { cost : 6000, force : Math.pow(1.25, 5) }, // 3.05
    ],
    [
      { cost :  200, rotSpeed : 1.2 * Math.pow(1.25, 1), tToRot : 0.17 },
      { cost :  600, rotSpeed : 1.2 * Math.pow(1.25, 2), tToRot : 0.13 }, 
      { cost : 1800, rotSpeed : 1.2 * Math.pow(1.25, 3), tToRot : 0.09  }, 
      { cost : 4000, rotSpeed : 1.2 * Math.pow(1.25, 4), tToRot : 0.05 }, // 2.92 
    ],
    [
      { cost :  400, zoom : 1.1 },
      { cost :  800, zoom : 1.0 }, 
      { cost : 1600, zoom : 0.9  }, 
      { cost : 3200, zoom : 0.8 },
    ],
    [
      { cost :  100, zoom : 1.1 },
    ],
    [
      { cost :  400, damage : 9 * Math.pow(1.5, 1) },
      { cost :  800, damage : 9 * Math.pow(1.5, 2) }, 
      { cost : 1600, damage : 9 * Math.pow(1.5, 3) }, 
      { cost : 3200, damage : 9 * Math.pow(1.5, 4) }, 
      { cost : 6400, damage : 9 * Math.pow(1.5, 5) }, // 3.05
    ],
    [
      { cost :  150, rate : 1.4 * Math.pow(1.25, 1) },
      { cost :  350, rate : 1.4 * Math.pow(1.25, 2) }, 
      { cost :  900, rate : 1.4 * Math.pow(1.25, 3) }, 
      { cost : 1800, rate : 1.4 * Math.pow(1.25, 4) }, 
      { cost : 4500, rate : 1.4 * Math.pow(1.25, 5) }, // 3.05
    ],
  ];
  
  this.display;
  
  this.closeButton;
  
  this.upgradesUnlocked = [ true, true, true, false, false, false ];
  this.currentUpgrade = [ 0, 0, 0, 0, 0, 0 ];
  
  this.upgradeTitle;
  this.upgradeText;
  this.upgradePrice;
  this.upgradeButtons = [];
  
  
  this.init = function() {
    
    this.display = false;
    
    this.closeButton = new Button();
    this.closeButton.init("close_upgrade", "close", 539, 470, function() {
      panel.closeWindow();
    });
    this.closeButton.setActive(false);
    
    this.upgradeTitle = new Text();
    this.upgradeTitle.setFont("medium");
    
    this.upgradeText = new Text();
    this.upgradeText.setFont("small");
    
    this.upgradePrice = new Text();
    this.upgradePrice.setFont("small");
    this.upgradePrice.setAlignment(Text.RIGHT);
    
    for(var i = 0; i < 6; i++) {
      this.upgradeButtons[i] = new Button();
    }
    this.upgradeButtons[0].init("upgrade0", "upgrade", 366, this.UPGRADE_OFFSET_Y[0] + 6, function() { upgradeWindow.upgrade(0); });
    this.upgradeButtons[1].init("upgrade1", "upgrade", 366, this.UPGRADE_OFFSET_Y[1] + 6, function() { upgradeWindow.upgrade(1); });
    this.upgradeButtons[2].init("upgrade2", "upgrade", 366, this.UPGRADE_OFFSET_Y[2] + 6, function() { upgradeWindow.upgrade(2); });
    this.upgradeButtons[3].init("upgrade3", "upgrade", 366, this.UPGRADE_OFFSET_Y[3] + 6, function() { upgradeWindow.upgrade(3); });
    this.upgradeButtons[4].init("upgrade4", "upgrade", 366, this.UPGRADE_OFFSET_Y[4] + 6, function() { upgradeWindow.upgrade(4); });
    this.upgradeButtons[5].init("upgrade5", "upgrade", 366, this.UPGRADE_OFFSET_Y[5] + 6, function() { upgradeWindow.upgrade(5); });
    for(var i = 0; i < 6; i++) {
      this.upgradeButtons[i].setActive(false);
    }
    this.upgradeButtons
  };
  
  
  this.show = function() {
    this.display = true;
    this.closeButton.setActive(true);
    this.updateButtons();
  };
  
  
  this.hide = function() {
    this.display = false;
    this.closeButton.setActive(false);
    for(var i = 0; i < 6; i++) {
      this.upgradeButtons[i].setActive(false);
    }
  };
  
  
  this.upgrade = function(upgrade) {
    
    var upgradeInfo = this.UPGRADES[upgrade][this.currentUpgrade[upgrade]];
    
    if(upgrade == 0) {
      player.forwardForce = upgradeInfo.force;
      
    } else if(upgrade == 1) {
      player.rotationSpeed = upgradeInfo.rotSpeed;
      player.timeToTopRotationSpeed = upgradeInfo.tToRot;
      
    } else if(upgrade == 2) {
      player.tempZoom = upgradeInfo.zoom;
      
    } else if(upgrade == 3) {
      
    } else if(upgrade == 4) {
      player.shotDamage = upgradeInfo.damage;
      
    } else if(upgrade == 5) {
      player.fireRate = upgradeInfo.rate;
    }
    
    player.money -= upgradeInfo.cost;
    this.currentUpgrade[upgrade]++;
    this.updateButtons();
  };
  
  
  this.updateButtons = function() {
    for(var i = 0; i < 6; i++) {
      if(this.upgradesUnlocked[i]) {
        if(this.currentUpgrade[i] == this.UPGRADES[i].length) {
          this.upgradeButtons[i].setActive(false);
        } else {
          if(player.money < this.UPGRADES[i][this.currentUpgrade[i]].cost) {
            this.upgradeButtons[i].setActive(false);
          } else {
            this.upgradeButtons[i].setActive(true);
          }
        }
      }
    }
  };
  
  
  this.draw = function() {
    
    img.draw("popup", 0, 0);
    
    img.draw("upgradeWindow", 70, 70);
    
    this.closeButton.draw();
    
    for(var i = 0; i < 6; i++) {
      
      if(i != 3) {
        if(this.upgradesUnlocked[i]) {
          
          img.drawSprite("upgrades", 112, this.UPGRADE_OFFSET_Y[i], 42, 42, 0, i);
          
          this.upgradeTitle.setPosition(159, this.UPGRADE_OFFSET_Y[i] + 5);
          this.upgradeTitle.text(this.UPGRADE_TITLES[i]);
          this.upgradeTitle.draw();
          
          this.upgradeText.setPosition(159, this.UPGRADE_OFFSET_Y[i] + 24);
          this.upgradeText.text(this.UPGRADE_TEXTS[i]);
          this.upgradeText.draw();
          
          if(this.currentUpgrade[i] < this.UPGRADES[i].length) {
          
            this.upgradePrice.setPosition(356, this.UPGRADE_OFFSET_Y[i] + 15);
            this.upgradePrice.text("$" + this.UPGRADES[i][this.currentUpgrade[i]].cost.toString());
            this.upgradePrice.draw();
            
            this.upgradeButtons[i].draw();
            
          }
          
        } else {
          
          img.drawSprite("upgrades", 112, this.UPGRADE_OFFSET_Y[i], 42, 42, 0, 6);
          
          this.upgradeText.setPosition(159, this.UPGRADE_OFFSET_Y[i] + 15);
          this.upgradeText.text("locked");
          this.upgradeText.draw();
          
        }   
      }   
      
    }
    
  };
  
}